=== debian/changelog ===
libsbml (5.2.0-1) unstable; urgency=low

  * update from upstream

 -- Ivo Maintz <ivo@maintz.de>  Mon, 14 Nov 2011 13:08:05 +0100

libsbml (5.1.0~b0-1) unstable; urgency=low

  * Upstream update
  * Fix debian/watch to find new upstream versions [Steffen]

 -- Ivo Maintz <ivo@maintz.de>  Mon, 19 Sep 2011 15:33:42 +0200

libsbml (3.4.0-1) UNRELEASED; urgency=low

  * Upstream update.

 -- Moriyoshi Koizumi <mozo@sfc.keio.ac.jp>  Tue, 16 Jun 2009 19:42:00 +0900

libsbml (3.3.2-1) UNRELEASED; urgency=low

  * Upstream update.

 -- Moriyoshi Koizumi <mozo@sfc.keio.ac.jp>  Wed, 03 Jun 2009 02:30:07 +0900

libsbml (3.3.1-1) UNRELEASED; urgency=low

  * Initial release (Closes: #241111)

 -- David Paleino <d.paleino@gmail.com>  Tue, 10 Feb 2009 14:36:09 +0100
