=== debian/control ===
Source: libsbml
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Ivo Maintz <ivo@maintz.de>,
 Changyan Xie <panchoat@gmail.com>,
 Moriyoshi Koizumi <mozo@sfc.keio.ac.jp>,
DM-Upload-Allowed: yes
Build-Depends: debhelper (>= 7),
 autoconf,
 automake,
 swig (>= 2),
 ruby1.8,
 libxml2-dev,
 python-dev,
 ruby1.8-dev,
 perl,
 libperl-dev,
 default-jdk | openjdk-6-jdk | java-gcj-compat-dev | java-sdk,
 octave-pkg-dev,
 python-support,
 doxygen (>= 1.5.8),
 graphviz,
 zlib1g-dev,
 libbz2-dev,
 c-sharp-compiler,
 cli-common-dev,
 cli-runtime
Standards-Version: 3.9.2
Section: science
Vcs-Browser: http://svn.debian.org/wsvn/debian-med/trunk/packages/libsbml/trunk/
Vcs-Svn: svn://svn.debian.org/svn/debian-med/trunk/packages/libsbml

Package: libsbml5-dev
Section: libdevel
Provides: libsbml-dev
Conflicts: libsbml3-dev
Architecture: any
Suggests: libsbml5-doc
Depends: libsbml5 (= ${binary:Version})
Description: System Biology Markup Language library - development files
 LibSBML is a library designed to help you read, write, manipulate,
 translate, and validate SBML files and data streams. It is not an
 application itself (though it does come with many example programs),
 but rather a library you can embed in your own applications.
 This package contains files necessary for development with libsbml.

Package: libsbml5-dbg
Section: debug
Priority: extra
Provides: libsbml-dbg
Conflicts: libsbml3-dbg
Architecture: any
Depends: libsbml5 (= ${binary:Version})
Description: System Biology Markup Language library - debug symbols
 LibSBML is a library designed to help you read, write, manipulate,
 translate, and validate SBML files and data streams. It is not an
 application itself (though it does come with many example programs),
 but rather a library you can embed in your own applications.
 This package contains th debugging symbols for libsbml.

Package: libsbml5
Section: libs
Architecture: any
Provides: libsbml
Conflicts: libsbml1, libsbml2, libsbml3
Suggests: libsbml5-doc
Depends: ${shlibs:Depends},
 ${misc:Depends}
Description: System Biology Markup Language library
 LibSBML is a library designed to help you read, write, manipulate,
 translate, and validate SBML files and data streams. It is not an
 application itself (though it does come with many example programs),
 but rather a library you can embed in your own applications.

Package: libsbml5-python
Section: python
Provides: ${python:Provides},
 python-sbml,
 libsbml-python
Conflicts: python-sbml3,
 libsbml4-python,
 libsbml-python
Architecture: any
Suggests: libsbml5-python-doc
Depends: ${shlibs:Depends},
 ${misc:Depends},
 ${python:Depends}
Description: System Biology Markup Language library - Python bindings
 LibSBML is a library designed to help you read, write, manipulate,
 translate, and validate SBML files and data streams. It is not an
 application itself (though it does come with many example programs),
 but rather a library you can embed in your own applications.
 This package contains the Python bindings of LibSBML.

#Package: libsbml5-matlab
#Section: non-free/math
#Provides: libsbml-matlab
#Conflicts: libsbml4-matlab
#Architecture: amd64
#Suggests: libsbml5-matlab-doc
#Depends: ${shlibs:Depends}, ${misc:Depends},
# libsbml5,
# libc6 (>= 2.3)
#Description: System Biology Markup Language library - Matlab bindings
# LibSBML is a library designed to help you read, write, manipulate,
# translate, and validate SBML files and data streams. It is not an
# application itself (though it does come with many example programs),
# but rather a library you can embed in your own applications.
# This package contains the Matlab bindings of LibSBML.

Package: libsbml5-ruby1.8
Section: ruby
Provides: libsbml-ruby
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Description: System Biology Markup Language library - Ruby binding
 LibSBML is a library designed to help you read, write, manipulate,
 translate, and validate SBML files and data streams. It is not an
 application itself (though it does come with many example programs),
 but rather a library you can embed in your own applications.
 This package contains the Ruby binding of LibSBML.

Package: libsbml5-java
Section: java
Provides: libsbml-java
Conflicts: libsbml3-java,
 libsbml4-java
Architecture: any
Suggests: libsbml5-java-doc
Depends: ${shlibs:Depends},
 ${misc:Depends}
Description: System Biology Markup Language library - Java binding
 LibSBML is a library designed to help you read, write, manipulate,
 translate, and validate SBML files and data streams. It is not an
 application itself (though it does come with many example programs),
 but rather a library you can embed in your own applications.
 This Package contains the Java binding of LibSBML.

Package: libsbml5-perl
Section: perl
Provides: libsbml-perl
Conflicts: libsbml3-perl
Suggests: libsbml5-perl-doc
Depends: ${shlibs:Depends},
 ${perl:Depends},
 ${misc:Depends}
Architecture: any
Description: System Biology Markup Language library - Perl binding
 LibSBML is a library designed to help you read, write, manipulate,
 translate, and validate SBML files and data streams. It is not an
 application itself (though it does come with many example programs),
 but rather a library you can embed in your own applications.
 This package contains the Perl binding of LibSBML.

Package: libsbml5-octave
Section: math
Provides: libsbml-octave
Suggests: libsbml5-octave-doc
Depends: ${shlibs:Depends},
 ${misc:Depends},
 octave3.2,
 libc6 (>=2.4)
Architecture: any
Description: System Biology Markup Language library - Octave binding
 LibSBML is a library designed to help you read, write, manipulate,
 translate, and validate SBML files and data streams. It is not an
 application itself (though it does come with many example programs),
 but rather a library you can embed in your own applications.
 This package contains the Octave binding of LibSBML.

Package: libsbml5-cil
Section: cli-mono
Provides: libsbml-cil
Suggests: libsbml5-cil-doc
Depends: ${shlibs:Depends},
 ${misc:Depends},
 ${cli:Depends}
Architecture: any
Description: System Biology Markup Language library - CLR binding
 LibSBML is a library designed to help you read, write, manipulate,
 translate, and validate SBML files and data streams. It is not an
 application itself (though it does come with many example programs),
 but rather a library you can embed in your own applications.
 This package contains the CLR binding of LibSBML.

Package: libsbml5-doc
Section: doc
Architecture: all
Depends: ${misc:Depends},
 libjs-jquery
Description: System Biology Markup Language library - C / C++ API docs
 LibSBML is a library designed to help you read, write, manipulate,
 translate, and validate SBML files and data streams. It is not an
 application itself (though it does come with many example programs),
 but rather a library you can embed in your own applications.
 This package contains C / C++ API documentation of LibSBML.

Package: libsbml5-perl-doc
Section: doc
Architecture: all
Depends: ${misc:Depends},
 libjs-jquery
Description: System Biology Markup Language library - Perl API docs
 LibSBML is a library designed to help you read, write, manipulate,
 translate, and validate SBML files and data streams. It is not an
 application itself (though it does come with many example programs),
 but rather a library you can embed in your own applications.
 This package contains Perl API documentation of LibSBML.

Package: libsbml5-python-doc
Section: doc
Architecture: all
Depends: ${misc:Depends},
 libjs-jquery
Description: System Biology Markup Language library - Python API docs
 LibSBML is a library designed to help you read, write, manipulate,
 translate, and validate SBML files and data streams. It is not an
 application itself (though it does come with many example programs),
 but rather a library you can embed in your own applications.
 This package contains Python API documentation of LibSBML.

Package: libsbml5-cil-doc
Section: doc
Architecture: all
Depends: ${misc:Depends},
 libjs-jquery
Description: System Biology Markup Language library - csharp API docs
 LibSBML is a library designed to help you read, write, manipulate,
 translate, and validate SBML files and data streams. It is not an
 application itself (though it does come with many example programs),
 but rather a library you can embed in your own applications.
 This package contains csharp API documentation of LibSBML.

Package: libsbml5-octave-doc
Section: doc
Architecture: all
Depends: ${misc:Depends},
 libjs-jquery
Description: System Biology Markup Language library - octave API docs
 LibSBML is a library designed to help you read, write, manipulate,
 translate, and validate SBML files and data streams. It is not an
 application itself (though it does come with many example programs),
 but rather a library you can embed in your own applications.
 This package contains octave API documentation of LibSBML.

#Package: libsbml5-matlab-doc
#Section: doc
#Architecture: all
#Depends: ${misc:Depends},
# libjs-jquery
#Description: System Biology Markup Language library - matlab API docs
# LibSBML is a library designed to help you read, write, manipulate,
# translate, and validate SBML files and data streams. It is not an
# application itself (though it does come with many example programs),
# but rather a library you can embed in your own applications.
# This package contains matlab API documentation of LibSBML.

Package: libsbml5-examples
Section: doc
Architecture: all
Depends: ${misc:Depends}
Suggests: libsbml5-dev (= ${binary:Version})
Description: System Biology Markup Language library -- example files
 LibSBML is a library designed to help you read, write, manipulate,
 translate, and validate SBML files and data streams. It is not an
 application itself (though it does come with many example programs),
 but rather a library you can embed in your own applications.
 This package contains C/C++, Java, Perl and layout examples.
